// Processed by NMI's Java Code Viewer 4.8.3  1997-2000 B. Lemaire
// Website: http://njcv.htmlplanet.com	E-mail: info@njcv.htmlplanet.com
// Copy registered to Evaluation Copy
// Source File Name:   Pendu.java

import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.*;
import java.io.InputStream;
import java.io.StreamTokenizer;
import java.net.URL;

public class Pendu extends Applet
    implements Runnable {

    String RepSon;
    String SonMsg;
    String SonGagne;
    String SonPerd;
    String Image;
    String Texte;
    String Language;
    String ButtonName;
    int imgsWidth;
    int imgsHeight;
    int nimgs;
    int Init;
    String Lettre_a_jouer;
    String Lettre_jouee;
    String Msg;
    String Mot;
    String MotAff;
    String ErrorMsg;
    Thread runner;
    int Niveau;
    int Point;
    int ErrorPendu;
    int Debug;
    Image imgs;
    AudioClip Bip;
    AudioClip Gagne;
    AudioClip Perdu;

    public void init() {
        String sParam = getParameter("Langue");
        if(sParam == null)
            Language = "FR";
        else
            Language = sParam.toUpperCase();
        sParam = getParameter("RepSon");
        if(sParam == null)
            RepSon = "son/";
        else
            RepSon = sParam + "/";
        sParam = getParameter("SonMsg");
        if(sParam == null)
            SonMsg = "bip.au";
        else
            SonMsg = sParam;
        sParam = getParameter("SonGagne");
        if(sParam == null)
            SonGagne = "applause.au";
        else
            SonGagne = sParam;
        sParam = getParameter("SonPerd");
        if(sParam == null)
            SonPerd = "ooh.au";
        else
            SonPerd = sParam;
        sParam = getParameter("Dessin");
        if(sParam == null)
            Image = "image/pendu.gif";
        else
            Image = sParam;
        sParam = getParameter("Texte");
        if(sParam == null)
            Texte = "son/francais.txt";
        else
            Texte = sParam;
        sParam = getParameter("NbImage");
        if(sParam == null)
            nimgs = 10;
        else
            nimgs = Integer.valueOf(sParam).intValue();
        if(Language.equals("GB"))
            ButtonName = "New Game";
        else
            ButtonName = "Nouvelle Partie";
        add(new Button(ButtonName));
        Bip = getAudioClip(getCodeBase(), RepSon + SonMsg);
        Gagne = getAudioClip(getCodeBase(), RepSon + SonGagne);
        Perdu = getAudioClip(getCodeBase(), RepSon + SonPerd);
    }

    public boolean action(Event evt, Object arg) {
        String Argument = (String)arg;
        if(Argument.equals(ButtonName)) {
            Msg = "";
            NouveauMot();
        }
        return true;
    }

    public void start() {
        if(runner == null) {
            runner = new Thread(this);
            runner.start();
        }
    }

    public void stop() {
        if(runner != null) {
            runner.stop();
            runner = null;
        }
    }

    public void run() {
        if(Image != null) {
            imgs = getImage(getCodeBase(), Image);
            repaint();
            NouveauMot();
            while(runner != null) 
                try {
                    Thread.sleep(1000L);
                }
                catch(InterruptedException _ex) { }
            return;
        } else {
            ErrorPendu = 1;
            ErrorMsg = "Param\352tre Dessin Manquant";
            return;
        }
    }

    public boolean keyDown(Event evt, int key) {
        if(Niveau < 10) {
            TestLettre(Character.toUpperCase((char)key));
            repaint();
        }
        return true;
    }

    void GetTaille(Graphics Fond) {
        if(Init == 0) {
            Fond.clipRect(0, 0, 0, 0);
            Fond.drawImage(imgs, 0, 0, this);
            Init = 1;
        }
        imgsHeight = imgs.getHeight(this);
        imgsWidth = imgs.getWidth(this);
        if(imgsWidth == -1 || imgsHeight == -1) {
            repaint();
            Debug = Debug + 1;
            return;
        } else {
            Init = 2;
            return;
        }
    }

    void DesRect(Graphics Fond1, int PosX, int PosY, int PosW, int PosH, int Border) {
        int Bord = 0;
        Fond1.setColor(Color.gray);
        for(Bord = 0; Bord < Border; Bord++) {
            Fond1.drawLine(PosX + Bord, PosY, PosX + Bord, (PosY + PosH) - Bord);
            Fond1.drawLine(PosX, PosY + Bord, (PosX + PosW) - Bord, PosY + Bord);
        }

        Fond1.setColor(Color.white);
        for(Bord = 0; Bord < Border; Bord++) {
            Fond1.drawLine((PosX + PosW) - Bord, PosY + Bord, (PosX + PosW) - Bord, PosY + PosH);
            Fond1.drawLine(PosX + Bord, (PosY + PosH) - Bord, PosX + PosW, (PosY + PosH) - Bord);
        }

    }

    void AfficheImage(Graphics Fond, int PosX, int PosY, int Position) {
        DesRect(Fond, PosX, PosY, imgsWidth / nimgs + 20, imgsHeight + 20, 3);
        int w = imgsWidth / nimgs;
        if(w != 0) {
            Fond.clipRect(PosX + 10, PosY + 10, w, imgsHeight + 20);
            Fond.drawImage(imgs, (PosX + 10) - (Position - 1) * w, PosY + 10, this);
        }
    }

    void TestLettre(char Lettre) {
        if((Lettre >= 'A') & (Lettre <= 'Z')) {
            int PosLettre = Lettre_a_jouer.indexOf(Lettre);
            if(PosLettre != -1) {
                Lettre_a_jouer = Lettre_a_jouer.substring(0, PosLettre) + " " + Lettre_a_jouer.substring(PosLettre + 1, 26);
                Lettre_jouee = Lettre_jouee.substring(0, PosLettre) + Lettre + Lettre_jouee.substring(PosLettre + 1, 26);
                Msg = "";
                TestMot(Lettre);
                return;
            }
            if(Language.equals("GB"))
                Msg = "This key has been pressed";
            else
                Msg = "Lettre d\351ja jou\351e";
            Bip.play();
        }
    }

    void TestMot(char Lettre) {
        int PosLettre = 0;
        int PosTemporaire = 0;
        int PointTemporaire = Point;
        for(String MotTemporaire = Mot; MotTemporaire.indexOf(Lettre) != -1;) {
            PosLettre = MotTemporaire.indexOf(Lettre);
            MotAff = MotAff.substring(0, PosTemporaire + PosLettre) + Lettre + MotAff.substring(PosTemporaire + PosLettre + 1, Mot.length());
            MotTemporaire = MotTemporaire.substring(PosLettre + 1, MotTemporaire.length());
            PosTemporaire = PosTemporaire + PosLettre + 1;
            Point = Point + 1;
        }

        if(PointTemporaire == Point)
            Niveau = Niveau + 1;
        if(Niveau == nimgs) {
            if(Language.equals("GB"))
                Msg = "You lose, it was " + Mot;
            else
                Msg = "Perdu, c'\351tait " + Mot;
            Perdu.play();
        }
        if(MotAff.indexOf("-") == -1) {
            if(Language.equals("GB"))
                Msg = "You WIN";
            else
                Msg = "Gagn\351";
            Gagne.play();
        }
    }

    public void NouveauMot() {
        Mot = Mot();
        if(ErrorPendu == 0) {
            MotAff = "";
            for(int Compte = 0; Compte != Mot.length(); Compte++)
                MotAff = MotAff + "-";

            Lettre_a_jouer = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
            Lettre_jouee = "                          ";
            Niveau = 0;
        } else {
            ErrorMsg = Mot();
        }
        repaint();
    }

    void AfficheBandeau(Graphics Fond, int PosX, int PosY) {
        Font fFont = new Font("Courier", 1, 20);
        Fond.setFont(fFont);
        FontMetrics fm = Fond.getFontMetrics(fFont);
        DesRect(Fond, PosX, PosY, size().width - 20, fm.getHeight() + 15, 3);
        int xstart = (size().width - fm.stringWidth(Lettre_a_jouer)) / 2;
        Fond.setColor(Color.green);
        Fond.drawString(Lettre_a_jouer, xstart, PosY + 5 + fm.getHeight());
        Fond.setColor(Color.red);
        Fond.drawString(Lettre_jouee, xstart, PosY + 5 + fm.getHeight());
    }

    void AfficheMsg(Graphics Fond, int PosX, int PosY) {
        Font fFont = new Font("TimesRoman", 1, 15);
        Fond.setFont(fFont);
        FontMetrics fm = Fond.getFontMetrics(fFont);
        DesRect(Fond, PosX, PosY, size().width - 2 * PosX, fm.getHeight() + 15, 3);
        Fond.setColor(Color.black);
        int xstart = (size().width - fm.stringWidth(Msg)) / 2;
        Fond.drawString(Msg, xstart, PosY + 5 + fm.getHeight());
    }

    void AfficheMot(Graphics Fond, int PosX, int PosY) {
        Font fFont = new Font("Courier", 1, 20);
        Fond.setFont(fFont);
        FontMetrics fm = Fond.getFontMetrics(fFont);
        DesRect(Fond, PosX, PosY, size().width - PosX - 10, fm.getHeight() + 15, 3);
        Fond.setColor(Color.gray);
        int xstart = (size().width - PosX - 10 - fm.stringWidth(MotAff)) / 2;
        Fond.drawString(MotAff, xstart + PosX, PosY + 5 + fm.getHeight());
    }

    void AfficheScore(Graphics Fond, int PosX, int PosY) {
        DesRect(Fond, PosX, PosY, size().width - PosX - 10, imgsHeight - 25, 3);
        Font fFont = new Font("TimesRoman", 1, 30);
        Fond.setFont(fFont);
        FontMetrics fm = Fond.getFontMetrics(fFont);
        int xstart = (size().width - PosX - 10 - fm.stringWidth(Integer.toString(Point))) / 2;
        int ystart = (imgsHeight - 15) / 2;
        Fond.drawString(Integer.toString(Point), PosX + xstart, PosY + ystart);
    }

    public void AfficheTexte(Graphics Fond) {
        Fond.setColor(Color.red);
        String Texte = Mot();
        Font fFont = new Font("TimesRoman", 1, 15);
        Fond.setFont(fFont);
        FontMetrics fm = Fond.getFontMetrics(fFont);
        int xstart = (size().width - fm.stringWidth(Texte)) / 2;
        int ystart = ((size().height - imgsHeight) + fm.getHeight() / 2) / 2;
        Fond.drawString(Texte, xstart, ystart + imgsHeight);
    }

    public void paint(Graphics g) {
        if(ErrorPendu == 0) {
            if(Init == 0 || Init == 1) {
                GetTaille(g);
                return;
            } else {
                AfficheBandeau(g, 10, 38);
                AfficheMsg(g, 10, imgsHeight + 45 + 20 + 7 + 38);
                AfficheScore(g, imgsWidth / nimgs + 36, 83);
                AfficheMot(g, imgsWidth / nimgs + 36, imgsHeight + 27 + 38);
                AfficheImage(g, 10, 83, Niveau);
                return;
            }
        } else {
            g.setColor(Color.red);
            g.drawString(ErrorMsg, 5, 50);
            return;
        }
    }

    public String Mot() {
        String Line = "";
        InputStream is = null;
        int xcompteur = 0;
        int compteur = 0;
        try {
            is = (new URL(getCodeBase(), Texte)).openStream();
        }
        catch(Exception e) {
            Line = e.getMessage();
            ErrorPendu = 1;
        }
        if(Line.equals("")) {
            try {
                StreamTokenizer st = new StreamTokenizer(is);
                st.eolIsSignificant(true);
                st.commentChar(35);
                switch(st.nextToken()) {
                case -3: 
                    Line = st.sval;
                    if("nb".equals(st.sval) && st.nextToken() == -2)
                        compteur = (int)(Math.random() * st.nval) + 1;
                    break;
                }
                while(compteur != xcompteur) 
                    switch(st.nextToken()) {
                    case -3: 
                        Line = st.sval;
                        xcompteur++;
                        break;
                    }
                is.close();
            }
            catch(Exception e) {
                Line = e.getMessage();
            }
            return Line.toUpperCase();
        } else {
            return "ERREUR TEXTE: " + Line;
        }
    }

    public Pendu() {
        Lettre_a_jouer = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        Lettre_jouee = "                          ";
        Msg = "";
        MotAff = "";
        ErrorMsg = "";
    }
}
